#include <SoftwareSerial.h>

const int D0 = 2;
const int D1 = 3;
const int D2 = 4;
const int D3 = 5;
const int D4 = 6;
const int D5 = 7;
const int D6 = 8;
const int D7 = 9;
const int CLK = 10;
const int Busy = 11;
const byte rxPin = 12;
const byte txPin = 13;

byte mididata = 127;
byte chn=0;
byte note=0;
byte c=0;

SoftwareSerial mySerial =  SoftwareSerial(rxPin, txPin);

void  setup() 
{
  pinMode(A0, OUTPUT);  //Red LED
  pinMode(A1, OUTPUT);  //Green LED
  pinMode(A2, INPUT_PULLUP);
  digitalWrite(A1, LOW);
  digitalWrite(A0, HIGH);
  
  pinMode(D0, INPUT_PULLUP);
  pinMode(D1, INPUT_PULLUP);
  pinMode(D2, INPUT_PULLUP);
  pinMode(D3, INPUT_PULLUP);
  pinMode(D4, INPUT_PULLUP);
  pinMode(D5, INPUT_PULLUP);
  pinMode(D6, INPUT_PULLUP);
  pinMode(D7, INPUT_PULLUP);
  pinMode(CLK, INPUT_PULLUP); // CLK
  pinMode(Busy, OUTPUT);  // Busy
  pinMode(rxPin, INPUT);
  pinMode(txPin, OUTPUT);
  
  digitalWrite(D0, HIGH);
  digitalWrite(D1, HIGH);
  digitalWrite(D2, HIGH);
  digitalWrite(D3, HIGH);
  digitalWrite(D4, HIGH);
  digitalWrite(D5, HIGH);
  digitalWrite(D6, HIGH);
  digitalWrite(D7, HIGH);
  digitalWrite(CLK, HIGH);
  digitalWrite(Busy, LOW); 

  Serial.begin(31250);           
  delay(100);
  Serial.write(255);
  delay(100);
 
  for (chn=0; chn<16;chn++){  //mute all channel
    for (note=0; note<128; note++){
        Serial.write(128+chn);
        Serial.write(note);
        Serial.write(mididata);
      }
  }

  Serial.end();  
  digitalWrite(A0, LOW);
  digitalWrite(A1, HIGH);
 }

void loop()
{
  if (digitalRead(A2)==LOW)
  {  
    Serial.begin(31250);           
    digitalWrite(A0, LOW);
    digitalWrite(A1, HIGH);
    delay(100);
    Serial.write(255);
    delay(100);
    while (digitalRead(A2)==LOW)
    {
      if ((digitalRead(D0)==HIGH) && (digitalRead(CLK)==HIGH))
      {
        while ((digitalRead(D0)!=LOW) && (digitalRead(CLK)==HIGH))
        {}       
        while ((digitalRead(D0)==LOW) && (digitalRead(CLK)!=LOW))
        {}    
        while (digitalRead(CLK)!=HIGH)
        {}     
        digitalWrite(Busy, HIGH);
        mididata = (digitalRead(D0)*1);
        mididata = mididata+(digitalRead(D1)*2);
        mididata = mididata+(digitalRead(D2)*4);
        mididata = mididata+(digitalRead(D3)*8);
        mididata = mididata+(digitalRead(D4)*16);
        mididata = mididata+(digitalRead(D5)*32);
        mididata = mididata+(digitalRead(D6)*64);
        mididata = mididata+(digitalRead(D7)*128);
        Serial.write(mididata);
        digitalWrite(Busy, LOW);                 
      }
    }
    Serial.end();
  } 

  if (digitalRead(A2)==HIGH)
  {  
    Serial.begin(31250);           
    digitalWrite(A0, HIGH);
    digitalWrite(A1, HIGH);
    Serial.write(255);
    mySerial.begin(19200);
   
    while (digitalRead(A2)==HIGH) 
    {
      if (mySerial.available()>0)   
      {
        c = mySerial.read();
        Serial.write(c);   
      }          
    }
    for (chn=0; chn<16;chn++){  //mute all channel
      for (note=0; note<128; note++){
        Serial.write(128+chn);
        Serial.write(note);
        Serial.write(mididata);
      }
    }
    Serial.end();
    mySerial.end();
  }    
}

